routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
|run cmd
|php artisan make:auth
|php artisan migrate
|php artisan db:seed --class=PermissionTableSeeder
|php artisan db:seed --class=CreateAdminUserSeeder
|
|
*/
// Route test
// Route::get('/', function () {
//     return view('layouts.frontend');
// });

Route::get('/', 'FrontEndController@home');
Route::get('/sport','FrontEndController@sport');
Route::get('/sport-detail','FrontEndController@sportDetail');
Route::get('/technology','FrontEndController@technology');
Route::get('/technology-detail','FrontEndController@technologyDetail');
Route::get('/life','FrontEndController@life');
Route::get('/life-detail','FrontEndController@lifeDetail');
Route::get('/healthy-life','FrontEndController@healthyLife');
Route::get('/healthy-life-detail','FrontEndController@healthyLifeDetail');
Route::get('/entertainment','FrontEndController@entertainment');
Route::get('/entertainment-detail','FrontEndController@entertainmentDetail');
Route::get('/hang-out','FrontEndController@hangOut');
Route::get('/hang-out-detail','FrontEndController@hangOutDetail');

Route::get('/about', 'FrontEndController@about');
Route::get('/contact', 'FrontEndController@contact');

Auth::routes([
    'register' => false,
    'reset' => false,
    'verify' => false,
  ]);

Route::get('/home', 'HomeController@index')->name('home');

Route::group(['middleware' => ['auth']], function() {    

    Route::resource('article', 'ArticleController');
    Route::post('article/status/{id}', 'ArticleController@status');
    Route::resource('articletype', 'ArticleTypeController');
    Route::post('articletype/status/{id}', 'ArticleTypeController@status');
    Route::resource('user','UserController');
    Route::resource('role' , 'RoleController');

    // Configuration
    Route::get('configuration', 'ConfigurationController@index');

     //Clear route cache:
    Route::get('/clear-route-cache', function() {
        $exitCode = Artisan::call('route:cache');
        return back()->with('success','You has been clearred route successfully');
    });

    //Clear config cache:
    Route::get('/clear-cache-config', function() {
        $exitCode = Artisan::call('config:cache');
        return back()->with('success','You has been clearred config successfully');
    }); 

    // Clear application cache:
    Route::get('/clear-cache', function() {
        $exitCode = Artisan::call('cache:clear');
        return back()->with('success','You has been clearred cache successfully');
    });

    // Clear view cache:
    Route::get('/clear-view', function() {
        $exitCode = Artisan::call('view:clear');
        return back()->with('success','You has been clearred view successfully');
    });
});

Route::get('addlog', 'HomeController@addLog');
Route::get('logactivity', 'HomeController@logActivity');

//Multiple role & permission
//https://www.itsolutionstuff.com/post/laravel-58-user-roles-and-permissions-tutorialexample.html

app/Http/Controllers/RoleController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Http\Response;
use App\Http\Controllers\Controller;
use Spatie\Permission\Models\Role;
use Spatie\Permission\Models\Permission;
use DB;

class RoleController extends Controller
{
    /**
     * Display a listing of the resource./
     *
     * @return \Illuminate\Http\Response
     */

     
    function __construct()
    {
         $this->middleware('permission:role-list|role-create|role-edit|role-delete', ['only' => ['index','store']]);
         $this->middleware('permission:role-create', ['only' => ['create','store']]);
         $this->middleware('permission:role-edit', ['only' => ['edit','update']]);
         $this->middleware('permission:role-delete', ['only' => ['destroy']]);
    }


    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        $roles = Role::orderBy('id','DESC')->get();
        return view('backend.roles.index',compact('roles'));
    }


    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $permission = Permission::get();
        return view('backend.roles.create',compact('permission'));
    }


    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->validate($request, [
            'name' => 'required|unique:roles,name',
            'permission' => 'required',
        ]);

        $role = Role::create(['name' => $request->input('name')]);
        $role->syncPermissions($request->input('permission'));
        return redirect()->route('role.index')
                        ->with('success','Role created successfully');
    }
    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $role = Role::find($id);
        $rolePermissions = Permission::join("role_has_permissions","role_has_permissions.permission_id","=","permissions.id")
            ->where("role_has_permissions.role_id",$id)
            ->get();


        return view('backend.roles.show',compact('role','rolePermissions'));
    }


    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $role = Role::find($id);
        $permission = Permission::get();
        $rolePermissions = DB::table("role_has_permissions")->where("role_has_permissions.role_id",$id)
            ->pluck('role_has_permissions.permission_id','role_has_permissions.permission_id')
            ->all();


        return view('backend.roles.edit',compact('role','permission','rolePermissions'));
    }


    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $this->validate($request, [
            'name' => 'required',
            'permission' => 'required',
        ]);


        $role = Role::find($id);
        $role->name = $request->input('name');
        $role->save();


        $role->syncPermissions($request->input('permission'));


        return redirect()->route('role.index')
                        ->with('success','Role updated successfully');
    }
    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        DB::table("roles")->where('id',$id)->delete();
        return redirect()->back()
                        ->with('success','Role deleted successfully');
    }
}

resources/views/backend/roles/create.blade.php
@extends('layouts.backend')
@section('content')

<!-- Content Wrapper. Contains page content -->
<div class="content-wrapper">
	<!-- Content Header (Page header) -->
	<section class="content-header">
		<div class="container-fluid">
			<div class="row mb-2">
				<div class="col-sm-6">
					<h1>Dashboard</h1>
				</div>
				<div class="col-sm-6">
					<ol class="breadcrumb float-sm-right">
						<li class="breadcrumb-item">
							<a href="#">Home</a>
                        </li>
                        <li class="breadcrumb-item">
                        <a href="{{ url('roles') }}">Role</a>
                        </li>
						<li class="breadcrumb-item active">Roles List</li>
					</ol>
				</div>
			</div>
		</div>
		<!-- /.container-fluid -->
    </section>
    @if ($message = Session::get('success'))
        <div class="alert alert-success">
        <p>{{ $message }}</p>
        </div>
    @endif
	<!-- Main content -->
	<section class="content">
		<div class="row">
			<div class="col-12">				
				<div class="card">
					<div class="card-header">
                        <h3 class="card-title">Create New Role
                        {{-- @can('role-create') --}}
                        <a href="{{ route('roles.index') }}" class="btn btn-success btn-sm pull-left"> Roles List</a>
                        {{-- @endcan     --}}
                    </h3>
                    </div>
					<!-- /.card-header -->
					<div class="card-body">
                            {!! Form::open(array('route' => 'roles.store','method'=>'POST')) !!}
                            @csrf
                                             <div class="row">
                                <div class="col-xs-12 col-sm-12 col-md-12">
                                    <div class="form-group">
                                        <strong>Name:</strong>
                                        {!! Form::text('name', null, array('placeholder' => 'Name','class' => 'form-control')) !!}
                                        @csrf
                                    </div>
                                </div>                                
                                  
                                <div class="col-xs-12 col-sm-12 col-md-12">
                                    <div class="form-group">
                                        <strong>Permission:</strong>
                                        <br/>
                                        @foreach($permission as $key => $value)  
                                            @if ($key % 4 == 0)
                                            <br/>
                                            @endif                                        
                                            <label>{{ Form::checkbox('permission[]', $value->id, false, array('class' => 'name')) }}
                                                    {{ $value->name }}</label> 
                                                    
                                                   
                                                    {{-- <div class="col-sm-6">
                                                            <!-- checkbox -->
                                                            <div class="form-group clearfix">
                                                              <div class="icheck-primary d-inline">
                                                                <input type="checkbox" name="{{permission[], $value->id}}" id="checkboxPrimary,{{ $value->id}}">
                                                                <label for="checkboxPrimar,{{ $value->id}}">{{ $value->name }}
                                                                </label>
                                                              </div>
                                                            </div>
                                                          </div> --}}
                                            @if (($key + 1) % 4 == 0)
                                            <br/>
                                            @endif
                                        @endforeach
                                        @if(count($permission) % 3 != 0)
                                            <br>
                                        @endif
                                    </div>
                                </div>
                                <div class="col-xs-12 col-sm-12 col-md-12 text-center">
                                    <button type="submit" class="btn btn-primary">Submit</button>
                                </div>
                            </div>
                            {!! Form::close() !!}                
					</div>
					<!-- /.card-body -->
				</div>
                <!-- /.card -->                
			</div>
			<!-- /.col -->
		</div>
		<!-- /.row -->
	</section>
	<!-- /.content -->
</div>
<!-- /.content-wrapper -->
      
@endsection
@section('js')		
@endsection

resources/views/backend/roles/edit.blade.php
@extends('layouts.backend')
@section('content')

<!-- Content Wrapper. Contains page content -->
<div class="content-wrapper">
	<!-- Content Header (Page header) -->
	<section class="content-header">
		<div class="container-fluid">
			<div class="row mb-2">
				<div class="col-sm-6">
					<h1>Dashboard</h1>
				</div>
				<div class="col-sm-6">
					<ol class="breadcrumb float-sm-right">
						<li class="breadcrumb-item">
							<a href="#">Home</a>
                        </li>
                        <li class="breadcrumb-item">
                        <a href="{{ url('roles') }}">Role</a>
                        </li>
						<li class="breadcrumb-item active">Roles List</li>
					</ol>
				</div>
			</div>
		</div>
		<!-- /.container-fluid -->
    </section>
    @if ($message = Session::get('success'))
        <div class="alert alert-success">
        <p>{{ $message }}</p>
        </div>
    @endif
	<!-- Main content -->
	<section class="content">
		<div class="row">
			<div class="col-12">				
				<div class="card">
					<div class="card-header">
                        <h3 class="card-title">Create New Role
                        {{-- @can('role-create') --}}
                        <a href="{{ route('role.index') }}" class="btn btn-success btn-sm pull-left"> Roles List</a>
                        {{-- @endcan     --}}
                    </h3>
                    </div>
					<!-- /.card-header -->
					<div class="card-body">
                            {!! Form::model($role, ['method' => 'PATCH','route' => ['role.update', $role->id]]) !!}
                            @csrf
                            <div class="row">
                                <div class="col-xs-12 col-sm-12 col-md-12">
                                    <div class="form-group">
                                        <strong>Name:</strong>
                                        {!! Form::text('name', null, array('placeholder' => 'Name','class' => 'form-control')) !!}
                                    </div>
                                </div>
                                <div class="col-xs-12 col-sm-12 col-md-12">
                                    <div class="form-group">
                                        <strong>Permission:</strong>
                                        <br/>
                                        @foreach($permission as $value)
                                            <label>{{ Form::checkbox('permission[]', $value->id, in_array($value->id, $rolePermissions) ? true : false, array('class' => 'name')) }}
                                            {{ $value->name }}</label>
                                        <br/>
                                        @endforeach
                                    </div>
                                </div>
                                <div class="col-xs-12 col-sm-12 col-md-12 text-center">
                                    <button type="submit" class="btn btn-primary">Submit</button>
                                </div>
                            </div>
                            {!! Form::close() !!}              
					</div>
					<!-- /.card-body -->
				</div>
                <!-- /.card -->                
			</div>
			<!-- /.col -->
		</div>
		<!-- /.row -->
	</section>
	<!-- /.content -->
</div>
<!-- /.content-wrapper -->
      
@endsection
@section('js')		
@endsection

resources/views/backend/roles/index.blade.php
@extends('layouts.backend')
@section('content')

<!-- Content Wrapper. Contains page content -->
<div class="content-wrapper">
	<!-- Content Header (Page header) -->
	<section class="content-header">
		<div class="container-fluid">
			<div class="row mb-2">
				<div class="col-sm-6">
					<h1>Dashboard</h1>
				</div>
				<div class="col-sm-6">
					<ol class="breadcrumb float-sm-right">
						<li class="breadcrumb-item">
							<a href="#">Home</a>
                        </li>
                        <li class="breadcrumb-item">
                        <a href="{{ url('role') }}">Role</a>
                        </li>
						<li class="breadcrumb-item active">Roles List</li>
					</ol>
				</div>
			</div>
		</div>
		<!-- /.container-fluid -->
    </section>
  
	<!-- Main content -->
	<section class="content">
		<div class="row">
			<div class="col-12">	
                    @if ($message = Session::get('success'))
                    <div class="alert alert-success">
                    <p>{{ $message }}</p>
                    </div>
                @endif			
				<div class="card">
					<div class="card-header">
                        <h3 class="card-title">Roles List
                        {{-- @can('role-create') --}}
                        <a href="{{ route('role.create') }}" class="btn btn-success btn-sm pull-left"> Create New Role</a>
                        {{-- @endcan     --}}
                    </h3>
                    </div>
					<!-- /.card-header -->
					<div class="card-body">
						<table id="example1" class="table table-bordered table-striped dataTable">
							<thead>
								<tr>
									<tr>
                                        <th>No</th>
                                        <th>Name</th>
                                        <th width="280px">Action</th>
                                    </tr>
								</tr>
							</thead>
							<tbody>	
                                    @foreach ($roles as $key => $role)
                                    <tr>
                                        <td>{{ ++$key }}</td>
                                        <td>{{ $role->name }}</td>
                                        <td>
                                            <a class="btn btn-info btn-sm" href="{{ route('role.show',$role->id) }}"><i class="fas fa-eye"></i> Show</a>
                                            @can('role-edit')
                                                <a class="btn btn-primary btn-sm" href="{{ route('role.edit',$role->id) }}"><i class="fas fa-pencil-alt"></i> Edit</a>
                                            @endcan
                                            @can('role-delete')
                                                {!! Form::open(['method' => 'DELETE','route' => ['role.destroy', $role->id],'style'=>'display:inline']) !!}
                                                @csrf
                                                    {{ Form::button('<i class="fa fa-trash"></i> submit', ['type' => 'submit', 'class' => 'btn btn-danger btn-sm'] )  }}
                                                {!! Form::close() !!}
                                            @endcan
                                        </td>
                                    </tr>
                                    @endforeach
                            </tbody>
                        </table>                        
					</div>
					<!-- /.card-body -->
				</div>
                <!-- /.card -->                
			</div>
			<!-- /.col -->
		</div>
		<!-- /.row -->
	</section>
	<!-- /.content -->
</div>
<!-- /.content-wrapper -->
      
@endsection
@section('js')			
<script type="text/javascript">
$(function () {
    
    $('#example1').DataTable({
        "paging": true,
        "lengthChange": true,
        "searching": true,
        "ordering": true,
        "info": true,
        "autoWidth": true,
        "fixedHeader": {
            "header": true,
            "headerOffset": $('#header').height()
        },
        "oLanguage": {
            "sSearch": "Filter results:"
        },
        "responsive": false,
        "select": true,
        "destroy": true,
    });

    $('.toastrDefaultSuccess').click(function() {
      toastr.success('Lorem ipsum dolor sit amet, consetetur sadipscing elitr.')
    });
    $('.toastrDefaultInfo').click(function() {
      toastr.info('Lorem ipsum dolor sit amet, consetetur sadipscing elitr.')
    });
    $('.toastrDefaultError').click(function() {
      toastr.error('Lorem ipsum dolor sit amet, consetetur sadipscing elitr.')
    });
    $('.toastrDefaultWarning').click(function() {
      toastr.warning('Lorem ipsum dolor sit amet, consetetur sadipscing elitr.')
    });

  });
</script>
@endsection

resources/views/backend/roles/show.blade.php
@extends('layouts.backend')
@section('content')

<!-- Content Wrapper. Contains page content -->
<div class="content-wrapper">
	<!-- Content Header (Page header) -->
	<section class="content-header">
		<div class="container-fluid">
			<div class="row mb-2">
				<div class="col-sm-6">
					<h1>Dashboard</h1>
				</div>
				<div class="col-sm-6">
					<ol class="breadcrumb float-sm-right">
						<li class="breadcrumb-item">
							<a href="#">Home</a>
                        </li>
                        <li class="breadcrumb-item">
                        <a href="{{ url('roles') }}">Role</a>
                        </li>
						<li class="breadcrumb-item active">Roles List</li>
					</ol>
				</div>
			</div>
		</div>
		<!-- /.container-fluid -->
    </section>
    @if ($message = Session::get('success'))
        <div class="alert alert-success">
        <p>{{ $message }}</p>
        </div>
    @endif
	<!-- Main content -->
	<section class="content">
		<div class="row">
			<div class="col-12">				
				<div class="card">
					<div class="card-header">
                        <h3 class="card-title">Create New Role
                        {{-- @can('role-create') --}}
                        <a href="{{ route('roles.index') }}" class="btn btn-success btn-sm pull-left"> Roles List</a>
                        {{-- @endcan     --}}
                    </h3>
                    </div>
					<!-- /.card-header -->
					<div class="card-body">
                            <div class="col-xs-12 col-sm-12 col-md-12">
                                    <div class="form-group">
                                        <strong>Name:</strong>
                                        {{ $role->name }}
                                    </div>
                                </div>
                                <div class="col-xs-12 col-sm-12 col-md-12">
                                    <div class="form-group">
                                        <strong>Permissions:</strong>
                                        @if(!empty($rolePermissions))
                                            @foreach($rolePermissions as $v)
                                                <span class="badge bg-success">{{ $v->name }}</span>
                                            @endforeach
                                        @endif
                                    </div>
                                </div>     
					</div>
					<!-- /.card-body -->
				</div>
                <!-- /.card -->                
			</div>
			<!-- /.col -->
		</div>
		<!-- /.row -->
	</section>
	<!-- /.content -->
</div>
<!-- /.content-wrapper -->
      
@endsection
@section('js')		
@endsection